Skip to content

Flatpickr

This tutorial shows you how to integrate the Flatpickr date picker as a custom Handsontable cell editor, with per-column locale and format configuration.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
import { format, isValid, parseISO } from 'date-fns';
import flatpickr from 'flatpickr';
import 'flatpickr/dist/flatpickr.css';
import { editorFactory } from 'handsontable/editors';
import { rendererFactory } from 'handsontable/renderers';
registerAllModules();
const DATE_FORMAT_US = 'MM/dd/yyyy';
const DATE_FORMAT_EU = 'dd/MM/yyyy';
/* start:skip-in-preview */
const data = [
{
product: 'Dashboard Pro',
category: 'Analytics',
version: '3.2.0',
releaseDate: '2025-03-15',
status: 'Released',
downloads: 12450,
},
{
product: 'Form Builder',
category: 'Tools',
version: '2.1.0',
releaseDate: '2025-04-22',
status: 'Released',
downloads: 8320,
},
{
product: 'Chart Engine',
category: 'Analytics',
version: '4.0.0',
releaseDate: '2025-06-10',
status: 'Beta',
downloads: 3100,
},
{
product: 'Auth Module',
category: 'Security',
version: '1.5.2',
releaseDate: '2025-07-01',
status: 'Released',
downloads: 15600,
},
{
product: 'File Manager',
category: 'Storage',
version: '2.0.0',
releaseDate: '2025-08-18',
status: 'Planned',
downloads: 0,
},
{
product: 'Email Service',
category: 'Communication',
version: '3.1.0',
releaseDate: '2025-09-05',
status: 'Released',
downloads: 9870,
},
{
product: 'Search Index',
category: 'Tools',
version: '1.2.0',
releaseDate: '2025-10-12',
status: 'Beta',
downloads: 2450,
},
{
product: 'Cache Layer',
category: 'Infra',
version: '2.3.1',
releaseDate: '2025-11-28',
status: 'Planned',
downloads: 0,
},
];
/* end:skip-in-preview */
// Get the DOM element with the ID 'example1' where the Handsontable will be rendered
const container = document.querySelector('#example1');
const cellDefinition = {
validator: (value, callback) => {
callback(!value || isValid(parseISO(value)));
},
renderer: rendererFactory(({ td, value, cellProperties }) => {
const date = parseISO(value);
td.innerText = value && isValid(date) ? format(date, cellProperties.renderFormat) : value || '';
}),
editor: editorFactory({
init(editor) {
editor.input = editor.hot.rootDocument.createElement('INPUT');
editor.input.classList.add('flatpickr-editor');
editor.flatpickr = flatpickr(editor.input, {
dateFormat: 'Y-m-d',
disableMobile: true,
onClose: () => {
editor.finishEditing();
},
});
editor.preventCloseElement = editor.flatpickr.calendarContainer;
/**
* Prepare dark theme stylesheet for dynamic loading.
*/
editor._darkThemeLink = editor.hot.rootDocument.createElement('LINK');
editor._darkThemeLink.rel = 'stylesheet';
editor._darkThemeLink.href = 'https://cdn.jsdelivr.net/npm/flatpickr/dist/themes/dark.css';
},
afterClose(editor) {
editor.flatpickr.close();
},
afterOpen(editor) {
const isDark = editor.hot.rootDocument.documentElement.getAttribute('data-theme') === 'dark';
const head = editor.hot.rootDocument.head;
if (isDark && !editor._darkThemeLink.parentNode) {
head.appendChild(editor._darkThemeLink);
} else if (!isDark && editor._darkThemeLink.parentNode) {
head.removeChild(editor._darkThemeLink);
}
editor.flatpickr.open();
},
beforeOpen(editor, { cellProperties }) {
for (const key in cellProperties.flatpickrSettings) {
editor.flatpickr.set(key, cellProperties.flatpickrSettings[key]);
}
},
getValue(editor) {
return editor.input.value;
},
setValue(editor, value) {
editor.input.value = value;
editor.flatpickr.setDate(value ? new Date(value) : new Date());
},
}),
};
// Define configuration options for the Handsontable
const hotOptions = {
data,
colHeaders: ['Product', 'Version', 'Release (EU)', 'Release (US)', 'Status'],
autoRowSize: true,
rowHeaders: true,
height: 'auto',
width: '100%',
autoWrapRow: true,
headerClassName: 'htLeft',
columns: [
{ data: 'product', type: 'text', width: 200 },
{ data: 'version', type: 'text', width: 80 },
{
data: 'releaseDate',
width: 130,
allowInvalid: false,
...cellDefinition,
renderFormat: DATE_FORMAT_EU,
flatpickrSettings: {
locale: {
firstDayOfWeek: 1,
},
},
},
{
data: 'releaseDate',
width: 130,
allowInvalid: false,
...cellDefinition,
renderFormat: DATE_FORMAT_US,
flatpickrSettings: {
locale: {
firstDayOfWeek: 0,
},
},
},
{ data: 'status', type: 'text', width: 130 },
],
licenseKey: 'non-commercial-and-evaluation',
};
// Initialize the Handsontable instance with the specified configuration options
// eslint-disable-next-line no-unused-vars
const hot = new Handsontable(container, hotOptions);
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
import { format, isValid, parseISO } from 'date-fns';
import flatpickr from 'flatpickr';
import 'flatpickr/dist/flatpickr.css';
import { CellProperties } from 'handsontable/settings';
import { editorFactory } from 'handsontable/editors';
import { rendererFactory } from 'handsontable/renderers';
registerAllModules();
const DATE_FORMAT_US = 'MM/dd/yyyy';
const DATE_FORMAT_EU = 'dd/MM/yyyy';
/* start:skip-in-preview */
const data = [
{
product: 'Dashboard Pro',
category: 'Analytics',
version: '3.2.0',
releaseDate: '2025-03-15',
status: 'Released',
downloads: 12450,
},
{
product: 'Form Builder',
category: 'Tools',
version: '2.1.0',
releaseDate: '2025-04-22',
status: 'Released',
downloads: 8320,
},
{
product: 'Chart Engine',
category: 'Analytics',
version: '4.0.0',
releaseDate: '2025-06-10',
status: 'Beta',
downloads: 3100,
},
{
product: 'Auth Module',
category: 'Security',
version: '1.5.2',
releaseDate: '2025-07-01',
status: 'Released',
downloads: 15600,
},
{
product: 'File Manager',
category: 'Storage',
version: '2.0.0',
releaseDate: '2025-08-18',
status: 'Planned',
downloads: 0,
},
{
product: 'Email Service',
category: 'Communication',
version: '3.1.0',
releaseDate: '2025-09-05',
status: 'Released',
downloads: 9870,
},
{
product: 'Search Index',
category: 'Tools',
version: '1.2.0',
releaseDate: '2025-10-12',
status: 'Beta',
downloads: 2450,
},
{
product: 'Cache Layer',
category: 'Infra',
version: '2.3.1',
releaseDate: '2025-11-28',
status: 'Planned',
downloads: 0,
},
];
/* end:skip-in-preview */
// Get the DOM element with the ID 'example1' where the Handsontable will be rendered
const container = document.querySelector('#example1')!;
interface FlatpickrEditorInstance {
input: HTMLInputElement;
flatpickr: flatpickr.Instance;
preventCloseElement: HTMLElement;
_darkThemeLink: HTMLLinkElement;
}
const cellDefinition: Pick<
CellProperties,
'renderer' | 'validator' | 'editor'
> = {
validator: (value, callback) => {
callback(!value || isValid(parseISO(value)));
},
renderer: rendererFactory(({ td, value, cellProperties }) => {
const date = parseISO(value);
td.innerText = value && isValid(date) ? format(date, cellProperties.renderFormat) : value || '';
}),
editor: editorFactory<FlatpickrEditorInstance>({
init(editor) {
editor.input = editor.hot.rootDocument.createElement('INPUT') as HTMLInputElement;
editor.input.classList.add('flatpickr-editor');
editor.flatpickr = flatpickr(editor.input, {
dateFormat: 'Y-m-d',
disableMobile: true,
onClose: () => {
editor.finishEditing();
},
});
editor.preventCloseElement = editor.flatpickr.calendarContainer;
/**
* Prepare dark theme stylesheet for dynamic loading.
*/
editor._darkThemeLink = editor.hot.rootDocument.createElement('LINK') as HTMLLinkElement;
editor._darkThemeLink.rel = 'stylesheet';
editor._darkThemeLink.href = 'https://cdn.jsdelivr.net/npm/flatpickr/dist/themes/dark.css';
},
afterClose(editor) {
editor.flatpickr.close();
},
afterOpen(editor) {
const isDark = editor.hot.rootDocument.documentElement.getAttribute('data-theme') === 'dark';
const head = editor.hot.rootDocument.head;
if (isDark && !editor._darkThemeLink.parentNode) {
head.appendChild(editor._darkThemeLink);
} else if (!isDark && editor._darkThemeLink.parentNode) {
head.removeChild(editor._darkThemeLink);
}
editor.flatpickr.open();
},
beforeOpen(editor, { cellProperties }) {
for (const key in cellProperties.flatpickrSettings) {
editor.flatpickr.set(key as keyof flatpickr.Options.Options, cellProperties.flatpickrSettings[key]);
}
},
getValue(editor) {
return editor.input.value;
},
setValue(editor, value) {
editor.input.value = value;
editor.flatpickr.setDate(value ? new Date(value) : new Date());
},
}),
};
// Define configuration options for the Handsontable
const hotOptions: Handsontable.GridSettings = {
data,
colHeaders: ['Product', 'Version', 'Release (EU)', 'Release (US)', 'Status'],
autoRowSize: true,
rowHeaders: true,
height: 'auto',
width: '100%',
autoWrapRow: true,
headerClassName: 'htLeft',
columns: [
{ data: 'product', type: 'text', width: 200 },
{ data: 'version', type: 'text', width: 80 },
{
data: 'releaseDate',
width: 130,
allowInvalid: false,
...cellDefinition,
renderFormat: DATE_FORMAT_EU,
flatpickrSettings: {
locale: {
firstDayOfWeek: 1,
},
},
},
{
data: 'releaseDate',
width: 130,
allowInvalid: false,
...cellDefinition,
renderFormat: DATE_FORMAT_US,
flatpickrSettings: {
locale: {
firstDayOfWeek: 0,
},
},
},
{ data: 'status', type: 'text', width: 130 },
],
licenseKey: 'non-commercial-and-evaluation',
};
// Initialize the Handsontable instance with the specified configuration options
// eslint-disable-next-line no-unused-vars
const hot = new Handsontable(container, hotOptions);
CSS
.flatpickr-editor {
width: 100%;
height: 100%;
box-sizing: border-box !important;
border: none;
border-radius: 0;
outline: none;
box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
var(--ht-cell-editor-border-color, #1a42e8),
0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
var(--ht-cell-editor-shadow-color, transparent) !important;
background-color: var(--ht-cell-editor-background-color, #ffffff) !important;
padding: var(--ht-cell-vertical-padding, 4px)
var(--ht-cell-horizontal-padding, 8px) !important;
border: none !important;
font-family: inherit;
font-size: inherit;
line-height: inherit;
}
.flatpickr-editor:focus-visible {
border: none !important;
}
.flatpickr-editor.active {
box-shadow: none;
background-color: transparent;
border-radius: 0 !important;
border-radius: none;
}

Overview

This guide shows how to create a custom date picker cell using Flatpickr, a date picker library that provides better cross-browser consistency and more customization options than native HTML5 date inputs.

Difficulty: Intermediate Time: ~20 minutes Libraries: flatpickr, date-fns

What You’ll Build

A cell that:

  • Displays formatted dates (e.g., “12/31/2024” or “31/12/2024”)
  • Opens a beautiful calendar picker when edited
  • Supports per-column configuration (EU vs US date formats)
  • Handles locale-specific settings (first day of week)
  • Auto-closes and saves when a date is selected
  • Supports dark theme with dynamic stylesheet loading

Prerequisites

Terminal window
npm install flatpickr date-fns
  1. Import Dependencies

    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    import { format, isValid, parseISO } from 'date-fns';
    import flatpickr from 'flatpickr';
    import 'flatpickr/dist/flatpickr.css';
    import { editorFactory } from 'handsontable/editors';
    import { rendererFactory } from 'handsontable/renderers';
    registerAllModules();

    Why date-fns?

    • Lightweight, modular date formatting
    • Better than native toLocaleDateString() for consistency
    • Can be replaced with other libraries (moment, dayjs, etc.)
    • parseISO parses the yyyy-MM-dd values the recipe stores, and isValid guards validation and rendering against invalid dates

    Why editorFactory and rendererFactory?

    • editorFactory creates a custom editor with lifecycle hooks (init, beforeOpen, afterOpen, afterClose, getValue, setValue, etc.)
    • rendererFactory creates a custom renderer with access to cell properties
    • Both are Handsontable helpers that handle boilerplate like container creation, positioning, and lifecycle management
  2. Define Date Formats

    const DATE_FORMAT_US = 'MM/dd/yyyy';
    const DATE_FORMAT_EU = 'dd/MM/yyyy';

    Why constants?

    • Reusability across renderer and column configuration
    • Single source of truth
    • Add more formats (ISO, custom, etc.) by extending this list
  3. Create the Renderer

    The renderer displays the date in a human-readable format.

    renderer: rendererFactory(({ td, value, cellProperties }) => {
    const date = parseISO(value);
    td.innerText = value && isValid(date) ? format(date, cellProperties.renderFormat) : value || '';
    })

    What’s happening:

    • value is the raw date value (e.g., ISO string “2025-03-15”)
    • Empty values are shown as an empty string
    • parseISO() parses the ISO string; unlike new Date(), it rejects impossible dates such as “2025-02-30” instead of rolling them over to March
    • isValid() guards format(), which throws RangeError: Invalid time value for an invalid date; an unparseable value is shown as-is
    • cellProperties.renderFormat is a custom property we’ll set per column
    • format() from date-fns converts to desired format
    • Display the formatted date

    Why use cellProperties?

    • Allows different columns to display dates differently
    • One cell definition, multiple configurations

    Optional error highlighting for production:

    renderer: rendererFactory(({ td, value, cellProperties }) => {
    if (!value) {
    td.innerText = '';
    td.style.color = '';
    return;
    }
    const date = parseISO(value);
    if (!isValid(date)) {
    td.innerText = 'Invalid date';
    td.style.color = 'red';
    return;
    }
    td.innerText = format(date, cellProperties.renderFormat || 'MM/dd/yyyy');
    td.style.color = '';
    })
  4. Create the Validator

    validator: (value, callback) => {
    callback(!value || isValid(parseISO(value)));
    }

    What’s happening:

    • Uses parseISO and isValid from date-fns to validate the date
    • parseISO(value) always returns a Date object, so checking its type (isDate) accepts any input; isValid also rejects an Invalid Date
    • parseISO rejects impossible dates such as “2025-02-30”, which new Date() silently rolls over to “2025-03-02”
    • Empty values pass, so users can clear a cell
    • Returns true for valid dates and empty values, false for invalid ones

    Alternative validation approaches:

    // Using native JavaScript
    validator: (value, callback) => {
    const date = new Date(value);
    callback(!value || !isNaN(date.getTime()));
    }

    The native version also allows empty values, but new Date() rolls impossible dates such as “2025-02-30” over instead of rejecting them.

  5. Editor - Initialize (init)

    Create the input element, initialize Flatpickr, and prepare the dark theme.

    init(editor) {
    editor.input = editor.hot.rootDocument.createElement('INPUT') as HTMLInputElement;
    editor.input.classList.add('flatpickr-editor');
    editor.flatpickr = flatpickr(editor.input, {
    dateFormat: 'Y-m-d',
    disableMobile: true,
    onClose: () => {
    editor.finishEditing();
    },
    });
    editor.preventCloseElement = editor.flatpickr.calendarContainer;
    /**
    * Prepare dark theme stylesheet for dynamic loading.
    */
    editor._darkThemeLink = editor.hot.rootDocument.createElement('LINK') as HTMLLinkElement;
    editor._darkThemeLink.rel = 'stylesheet';
    editor._darkThemeLink.href = 'https://cdn.jsdelivr.net/npm/flatpickr/dist/themes/dark.css';
    }

    What’s happening:

    1. Create an input element and add the flatpickr-editor CSS class for styling
    2. Initialize Flatpickr on the input with an onClose handler that calls finishEditing() when the calendar closes (e.g., after selecting a date or pressing Escape)
    3. Set preventCloseElement to the Flatpickr calendar container so that clicks inside the calendar are not treated as “outside” clicks — this keeps the editor open while the user selects a date
    4. Create a <link> element for the dark theme (loaded dynamically in afterOpen)

    Key concepts:

    The onClose handler

    onClose: () => {
    editor.finishEditing();
    },

    When the user selects a date or closes the calendar (e.g., Escape), Flatpickr fires onClose. Calling finishEditing() saves the value and closes the editor.

    The CSS class

    editor.input.classList.add('flatpickr-editor');

    Adds a CSS class to style the input element using Handsontable’s CSS custom properties (tokens). See the CSS file for details.

    The preventCloseElement pattern

    Without it:

    1. User clicks cell to edit
    2. Flatpickr calendar opens
    3. User clicks on the calendar
    4. Handsontable treats the click as “outside” the editor and closes it

    Solution: Assign the Flatpickr calendar container to editor.preventCloseElement. The editor factory treats this element as part of the editor, so clicks inside it do not close the editor prematurely.

  6. Editor - After Close Hook (afterClose)

    Close the Flatpickr calendar when the editor is closed by non-Flatpickr means (e.g., Escape key or clicking outside).

    afterClose(editor) {
    editor.flatpickr.close();
    }

    What’s happening:

    • When the user closes the editor by pressing Escape or clicking outside the cell, Handsontable closes the editor but Flatpickr’s calendar popup is not automatically closed
    • The afterClose hook runs when the editor is about to close; calling editor.flatpickr.close() ensures the calendar is hidden
    • Without this hook, the calendar would remain visible on screen after the editor has closed
  7. Editor - After Open Hook (afterOpen)

    Toggle the dark theme when the editor opens, then open the Flatpickr calendar.

    afterOpen(editor) {
    const isDark = editor.hot.rootDocument.documentElement.getAttribute('data-theme') === 'dark';
    const head = editor.hot.rootDocument.head;
    if (isDark && !editor._darkThemeLink.parentNode) {
    head.appendChild(editor._darkThemeLink);
    } else if (!isDark && editor._darkThemeLink.parentNode) {
    head.removeChild(editor._darkThemeLink);
    }
    editor.flatpickr.open();
    }

    What’s happening:

    1. Check the current theme by reading the data-theme attribute on the <html> element
    2. Dynamically add or remove the Flatpickr dark theme stylesheet
    3. Call editor.flatpickr.open() to show the calendar (the editor factory does not open Flatpickr automatically)

    Why dynamic theme loading?

    • Flatpickr themes are CSS files, not runtime APIs
    • Importing CSS directly (import 'flatpickr/dist/themes/dark.css') doesn’t work in all build environments
    • Dynamic <link> injection allows toggling the theme each time the editor opens
    • The theme stylesheet is loaded from jsDelivr CDN and cached by the browser
  8. Editor - Before Open Hook (beforeOpen)

    Apply per-column Flatpickr settings.

    beforeOpen(editor, { cellProperties }) {
    for (const key in cellProperties.flatpickrSettings) {
    editor.flatpickr.set(key as keyof flatpickr.Options.Options, cellProperties.flatpickrSettings[key]);
    }
    }

    What’s happening:

    1. Update Flatpickr settings from cellProperties.flatpickrSettings (e.g., locale, first day of week)
    2. The editor’s value is set by the framework before beforeOpen runs

    Key points:

    • beforeOpen is called before the editor opens
    • cellProperties.flatpickrSettings contains column-specific Flatpickr configuration
    • flatpickr.set() updates the existing Flatpickr instance with new settings

    Why update settings in beforeOpen?

    • Allows different columns to have different Flatpickr configurations (e.g., EU vs US first day of week)
    • Settings are applied before opening, ensuring they are current
    • More efficient than reinitializing Flatpickr each time
  9. Editor - Get Value (getValue)

    Return the current date value from the input.

    getValue(editor) {
    return editor.input.value;
    }

    What’s happening:

    • Flatpickr automatically updates input.value in ISO format (e.g., “2025-03-15”)
    • Return the input’s current value
    • Called when Handsontable needs to save the cell value
  10. Editor - Set Value (setValue)

    Initialize the editor with the cell’s current date value.

    setValue(editor, value) {
    editor.input.value = value;
    editor.flatpickr.setDate(value ? new Date(value) : new Date());
    }

    What’s happening:

    • Set the input’s value to the provided date string
    • Update Flatpickr’s selected date using setDate() — use the cell value if present, otherwise the current date
    • This ensures Flatpickr displays the correct date when opened
    • Called to initialize the editor with the cell’s current value
  11. Style the Editor with CSS

    The editor input needs styling to match Handsontable’s cell appearance. Create a CSS file using Handsontable’s CSS custom properties (tokens):

    .flatpickr-editor {
    width: 100%;
    height: 100%;
    box-sizing: border-box !important;
    border: none;
    border-radius: 0;
    outline: none;
    box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
    var(--ht-cell-editor-border-color, #1a42e8),
    0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
    var(--ht-cell-editor-shadow-color, transparent) !important;
    background-color: var(--ht-cell-editor-background-color, #ffffff) !important;
    padding: var(--ht-cell-vertical-padding, 4px)
    var(--ht-cell-horizontal-padding, 8px) !important;
    border: none !important;
    font-family: inherit;
    font-size: inherit;
    line-height: inherit;
    }
    .flatpickr-editor:focus-visible {
    border: none !important;
    }
    .flatpickr-editor.active {
    box-shadow: none;
    background-color: transparent;
    border-radius: 0 !important;
    }

    Why use CSS custom properties?

    • --ht-cell-editor-border-width and --ht-cell-editor-border-color match the default Handsontable editor border
    • --ht-cell-editor-background-color ensures the editor background matches the cell
    • --ht-cell-vertical-padding and --ht-cell-horizontal-padding align text with the cell content
    • These tokens automatically adapt when using custom Handsontable themes

    The .active state: When the editor is active (calendar open), the input border and background are hidden since the calendar itself provides the visual feedback.

  12. Complete Cell Definition

    TypeScript: Define an interface for the editor instance (optional in JavaScript):

    interface FlatpickrEditorInstance {
    input: HTMLInputElement;
    flatpickr: flatpickr.Instance;
    preventCloseElement: HTMLElement;
    _darkThemeLink: HTMLLinkElement;
    }

    Put it all together:

    const cellDefinition = {
    validator: (value, callback) => {
    callback(!value || isValid(parseISO(value)));
    },
    renderer: rendererFactory(({ td, value, cellProperties }) => {
    const date = parseISO(value);
    td.innerText = value && isValid(date) ? format(date, cellProperties.renderFormat) : value || '';
    }),
    editor: editorFactory<FlatpickrEditorInstance>({
    init(editor) {
    editor.input = editor.hot.rootDocument.createElement('INPUT') as HTMLInputElement;
    editor.input.classList.add('flatpickr-editor');
    editor.flatpickr = flatpickr(editor.input, {
    dateFormat: 'Y-m-d',
    disableMobile: true,
    onClose: () => {
    editor.finishEditing();
    },
    });
    editor.preventCloseElement = editor.flatpickr.calendarContainer;
    editor._darkThemeLink = editor.hot.rootDocument.createElement('LINK') as HTMLLinkElement;
    editor._darkThemeLink.rel = 'stylesheet';
    editor._darkThemeLink.href = 'https://cdn.jsdelivr.net/npm/flatpickr/dist/themes/dark.css';
    },
    afterClose(editor) {
    editor.flatpickr.close();
    },
    afterOpen(editor) {
    const isDark = editor.hot.rootDocument.documentElement.getAttribute('data-theme') === 'dark';
    const head = editor.hot.rootDocument.head;
    if (isDark && !editor._darkThemeLink.parentNode) {
    head.appendChild(editor._darkThemeLink);
    } else if (!isDark && editor._darkThemeLink.parentNode) {
    head.removeChild(editor._darkThemeLink);
    }
    editor.flatpickr.open();
    },
    beforeOpen(editor, { cellProperties }) {
    for (const key in cellProperties.flatpickrSettings) {
    editor.flatpickr.set(key as keyof flatpickr.Options.Options, cellProperties.flatpickrSettings[key]);
    }
    },
    getValue(editor) {
    return editor.input.value;
    },
    setValue(editor, value) {
    editor.input.value = value;
    editor.flatpickr.setDate(value ? new Date(value) : new Date());
    },
    }),
    };

    What’s happening:

    • validator: Ensures date is valid using parseISO and isValid from date-fns
    • renderer: Displays formatted date using cellProperties.renderFormat (empty string for missing values, the raw value for invalid dates)
    • editor: Uses editorFactory helper with:
      • init: Creates input, initializes Flatpickr with onClose calling finishEditing(), sets preventCloseElement so calendar clicks don’t close the editor, prepares dark theme link
      • afterClose: Closes the Flatpickr calendar when the editor is closed by Escape or clicking outside
      • afterOpen: Toggles dark theme stylesheet and opens the Flatpickr calendar
      • beforeOpen: Applies per-column Flatpickr settings from cellProperties.flatpickrSettings
      • getValue: Returns the input’s current value
      • setValue: Sets input value and Flatpickr’s selected date

    Note: The editorFactory helper handles container creation, positioning, and lifecycle management automatically.

  13. Use in Handsontable with Different Formats

    const container = document.querySelector('#example1');
    const hotOptions = {
    data,
    colHeaders: ['Product', 'Version', 'Release (EU)', 'Release (US)', 'Status'],
    autoRowSize: true,
    rowHeaders: true,
    height: 'auto',
    width: '100%',
    autoWrapRow: true,
    headerClassName: 'htLeft',
    columns: [
    { data: 'product', type: 'text', width: 200 },
    { data: 'version', type: 'text', width: 80 },
    {
    data: 'releaseDate',
    width: 130,
    allowInvalid: false,
    ...cellDefinition,
    renderFormat: DATE_FORMAT_EU,
    flatpickrSettings: {
    locale: {
    firstDayOfWeek: 1,
    },
    },
    },
    {
    data: 'releaseDate',
    width: 130,
    allowInvalid: false,
    ...cellDefinition,
    renderFormat: DATE_FORMAT_US,
    flatpickrSettings: {
    locale: {
    firstDayOfWeek: 0,
    },
    },
    },
    { data: 'status', type: 'text', width: 130 },
    ],
    licenseKey: 'non-commercial-and-evaluation',
    };
    const hot = new Handsontable(container, hotOptions);

    TypeScript: Use const container = document.querySelector('#example1')! and type the options as Handsontable.GridSettings.

    Key feature:

    • Same data column (releaseDate)
    • Two different display formats (EU vs US)
    • Two different calendar configurations (Monday vs Sunday first day)
    • One cell definition!

How It Works - Complete Flow

  1. Initial Load: Cell displays formatted date (“15/03/2025” EU or “03/15/2025” US), empty string when there is no value, or the raw value when it isn’t a valid date
  2. User Double-Clicks or F2: Editor opens, container positioned over cell
  3. Before Open: beforeOpen applies per-column Flatpickr settings (e.g., first day of week)
  4. After Open: afterOpen toggles dark theme if needed and calls editor.flatpickr.open() to show the calendar
  5. Calendar Opens: Flatpickr displays the calendar with column-specific settings
  6. User Selects Date or Closes Calendar: onClose handler fires, calls finishEditing()
  7. Validation: Validator checks date is valid using parseISO and isValid
  8. Save: Value saved in ISO format (“2025-03-15”)
  9. Editor Closes: afterClose runs and closes the Flatpickr calendar (important when the user closed via Escape or clicking outside). Container hidden, cell renderer displays the new formatted date

Advanced Enhancements

  1. Time Picker

    Add time selection:

    flatpickrSettings: {
    enableTime: true,
    dateFormat: 'Y-m-d H:i',
    time_24hr: true
    }
    // Update renderer
    renderFormat: 'dd/MM/yyyy HH:mm'
  2. Date Range Restrictions

    Limit selectable dates:

    flatpickrSettings: {
    minDate: '2024-01-01',
    maxDate: '2024-12-31',
    disable: [
    // Disable weekends
    function(date) {
    return (date.getDay() === 0 || date.getDay() === 6);
    }
    ]
    }
  3. Inline Calendar

    Show calendar always visible:

    flatpickrSettings: {
    inline: true,
    static: true
    }
    // Adjust wrapper height in open()
    editor.container.style.height = '300px';
  4. Multiple Date Locales

    Use Flatpickr locales:

    import { French } from 'flatpickr/dist/l10n/fr.js';
    flatpickrSettings: {
    locale: French,
    dateFormat: 'd/m/Y'
    }
  5. Custom Date Ranges

    Add shortcuts:

    // Requires flatpickr shortcutButtonsPlugin
    import ShortcutButtonsPlugin from 'flatpickr/dist/plugins/shortcutButtons/shortcutButtons.js';
    flatpickrSettings: {
    plugins: [
    ShortcutButtonsPlugin({
    button: [
    { label: 'Today' },
    { label: 'Next Week' },
    ],
    onClick: (index, fp) => {
    let date;
    if (index === 0) {
    date = new Date();
    } else if (index === 1) {
    date = new Date();
    date.setDate(date.getDate() + 7);
    }
    fp.setDate(date);
    }
    })
    ]
    }

What you learned

You integrated the Flatpickr date picker as a Handsontable cell editor. You used editorFactory to manage the editor lifecycle, preventCloseElement to keep the calendar open while the user picks a date, and cellProperties to drive per-column format and locale configuration.

Next steps

  • Pikaday - An alternative date picker using Pikaday and Moment.js, with portal positioning.
  • Moment.js date - A date cell type that layers Moment.js formatting over the built-in date cell type.
  • Date picker (Angular) - A date editor built with Angular components and the native HTML5 date input.

Skip to content

Flatpickr

This tutorial shows you how to integrate the Flatpickr date picker as a custom Handsontable cell editor, with per-column locale and format configuration.

JavaScript
import { HotTable, HotColumn } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import { format, isValid, parseISO } from 'date-fns';
import flatpickr from 'flatpickr';
import 'flatpickr/dist/flatpickr.css';
import { editorFactory } from 'handsontable/editors';
import { rendererFactory } from 'handsontable/renderers';
import './example1.css';
registerAllModules();
const DATE_FORMAT_US = 'MM/dd/yyyy';
const DATE_FORMAT_EU = 'dd/MM/yyyy';
/* start:skip-in-preview */
const data = [
{
product: 'Dashboard Pro',
category: 'Analytics',
version: '3.2.0',
releaseDate: '2025-03-15',
status: 'Released',
downloads: 12450,
},
{
product: 'Form Builder',
category: 'Tools',
version: '2.1.0',
releaseDate: '2025-04-22',
status: 'Released',
downloads: 8320,
},
{
product: 'Chart Engine',
category: 'Analytics',
version: '4.0.0',
releaseDate: '2025-06-10',
status: 'Beta',
downloads: 3100,
},
{
product: 'Auth Module',
category: 'Security',
version: '1.5.2',
releaseDate: '2025-07-01',
status: 'Released',
downloads: 15600,
},
{
product: 'File Manager',
category: 'Storage',
version: '2.0.0',
releaseDate: '2025-08-18',
status: 'Planned',
downloads: 0,
},
{
product: 'Email Service',
category: 'Communication',
version: '3.1.0',
releaseDate: '2025-09-05',
status: 'Released',
downloads: 9870,
},
{
product: 'Search Index',
category: 'Tools',
version: '1.2.0',
releaseDate: '2025-10-12',
status: 'Beta',
downloads: 2450,
},
{
product: 'Cache Layer',
category: 'Infra',
version: '2.3.1',
releaseDate: '2025-11-28',
status: 'Planned',
downloads: 0,
},
];
/* end:skip-in-preview */
const flatpickrValidator = (value, callback) => {
callback(!value || isValid(parseISO(value)));
};
const flatpickrRenderer = rendererFactory(({ td, value, cellProperties }) => {
const date = parseISO(value);
td.innerText = value && isValid(date) ? format(date, cellProperties.renderFormat) : value || '';
});
const flatpickrEditor = editorFactory({
init(editor) {
editor.input = editor.hot.rootDocument.createElement('INPUT');
editor.input.classList.add('flatpickr-editor');
editor.flatpickr = flatpickr(editor.input, {
dateFormat: 'Y-m-d',
disableMobile: true,
onClose: () => {
editor.finishEditing();
},
});
editor.preventCloseElement = editor.flatpickr.calendarContainer;
editor._darkThemeLink = editor.hot.rootDocument.createElement('LINK');
editor._darkThemeLink.rel = 'stylesheet';
editor._darkThemeLink.href = 'https://cdn.jsdelivr.net/npm/flatpickr/dist/themes/dark.css';
},
afterClose(editor) {
editor.flatpickr.close();
},
afterOpen(editor) {
const isDark = editor.hot.rootDocument.documentElement.getAttribute('data-theme') === 'dark';
const head = editor.hot.rootDocument.head;
if (isDark && !editor._darkThemeLink.parentNode) {
head.appendChild(editor._darkThemeLink);
} else if (!isDark && editor._darkThemeLink.parentNode) {
head.removeChild(editor._darkThemeLink);
}
editor.flatpickr.open();
},
beforeOpen(editor, { cellProperties }) {
for (const key in cellProperties.flatpickrSettings) {
editor.flatpickr.set(key, cellProperties.flatpickrSettings[key]);
}
},
getValue(editor) {
return editor.input.value;
},
setValue(editor, value) {
editor.input.value = value;
editor.flatpickr.setDate(value ? new Date(value) : new Date());
},
});
const ExampleComponent = () => {
return (
<HotTable
data={data}
colHeaders={['Product', 'Version', 'Release (EU)', 'Release (US)', 'Status']}
autoRowSize={true}
rowHeaders={true}
height="auto"
width="100%"
autoWrapRow={true}
headerClassName="htLeft"
licenseKey="non-commercial-and-evaluation"
>
<HotColumn data="product" type="text" width={200} />
<HotColumn data="version" type="text" width={80} />
<HotColumn
data="releaseDate"
width={130}
allowInvalid={false}
hotRenderer={flatpickrRenderer}
hotEditor={flatpickrEditor}
validator={flatpickrValidator}
renderFormat={DATE_FORMAT_EU}
flatpickrSettings={{ locale: { firstDayOfWeek: 1 } }}
/>
<HotColumn
data="releaseDate"
width={130}
allowInvalid={false}
hotRenderer={flatpickrRenderer}
hotEditor={flatpickrEditor}
validator={flatpickrValidator}
renderFormat={DATE_FORMAT_US}
flatpickrSettings={{ locale: { firstDayOfWeek: 0 } }}
/>
<HotColumn data="status" type="text" width={130} />
</HotTable>
);
};
export default ExampleComponent;
TypeScript
import { HotTable, HotColumn } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import { format, isValid, parseISO } from 'date-fns';
import flatpickr from 'flatpickr';
import 'flatpickr/dist/flatpickr.css';
import { CellProperties } from 'handsontable/settings';
import { editorFactory } from 'handsontable/editors';
import { rendererFactory } from 'handsontable/renderers';
import './example1.css';
registerAllModules();
const DATE_FORMAT_US = 'MM/dd/yyyy';
const DATE_FORMAT_EU = 'dd/MM/yyyy';
/* start:skip-in-preview */
const data = [
{
product: 'Dashboard Pro',
category: 'Analytics',
version: '3.2.0',
releaseDate: '2025-03-15',
status: 'Released',
downloads: 12450,
},
{
product: 'Form Builder',
category: 'Tools',
version: '2.1.0',
releaseDate: '2025-04-22',
status: 'Released',
downloads: 8320,
},
{
product: 'Chart Engine',
category: 'Analytics',
version: '4.0.0',
releaseDate: '2025-06-10',
status: 'Beta',
downloads: 3100,
},
{
product: 'Auth Module',
category: 'Security',
version: '1.5.2',
releaseDate: '2025-07-01',
status: 'Released',
downloads: 15600,
},
{
product: 'File Manager',
category: 'Storage',
version: '2.0.0',
releaseDate: '2025-08-18',
status: 'Planned',
downloads: 0,
},
{
product: 'Email Service',
category: 'Communication',
version: '3.1.0',
releaseDate: '2025-09-05',
status: 'Released',
downloads: 9870,
},
{
product: 'Search Index',
category: 'Tools',
version: '1.2.0',
releaseDate: '2025-10-12',
status: 'Beta',
downloads: 2450,
},
{
product: 'Cache Layer',
category: 'Infra',
version: '2.3.1',
releaseDate: '2025-11-28',
status: 'Planned',
downloads: 0,
},
];
/* end:skip-in-preview */
interface FlatpickrEditorInstance {
input: HTMLInputElement;
flatpickr: flatpickr.Instance;
preventCloseElement: HTMLElement;
_darkThemeLink: HTMLLinkElement;
}
const flatpickrValidator = (value: string, callback: (valid: boolean) => void) => {
callback(!value || isValid(parseISO(value)));
};
const flatpickrRenderer = rendererFactory(({ td, value, cellProperties }) => {
const date = parseISO(value);
td.innerText = value && isValid(date) ? format(date, cellProperties.renderFormat) : value || '';
});
const flatpickrEditor = editorFactory<FlatpickrEditorInstance>({
init(editor) {
editor.input = editor.hot.rootDocument.createElement('INPUT') as HTMLInputElement;
editor.input.classList.add('flatpickr-editor');
editor.flatpickr = flatpickr(editor.input, {
dateFormat: 'Y-m-d',
disableMobile: true,
onClose: () => {
editor.finishEditing();
},
});
editor.preventCloseElement = editor.flatpickr.calendarContainer;
editor._darkThemeLink = editor.hot.rootDocument.createElement('LINK') as HTMLLinkElement;
editor._darkThemeLink.rel = 'stylesheet';
editor._darkThemeLink.href = 'https://cdn.jsdelivr.net/npm/flatpickr/dist/themes/dark.css';
},
afterClose(editor) {
editor.flatpickr.close();
},
afterOpen(editor) {
const isDark = editor.hot.rootDocument.documentElement.getAttribute('data-theme') === 'dark';
const head = editor.hot.rootDocument.head;
if (isDark && !editor._darkThemeLink.parentNode) {
head.appendChild(editor._darkThemeLink);
} else if (!isDark && editor._darkThemeLink.parentNode) {
head.removeChild(editor._darkThemeLink);
}
editor.flatpickr.open();
},
beforeOpen(editor, { cellProperties }) {
for (const key in cellProperties.flatpickrSettings) {
editor.flatpickr.set(key as keyof flatpickr.Options.Options, cellProperties.flatpickrSettings[key]);
}
},
getValue(editor) {
return editor.input.value;
},
setValue(editor, value) {
editor.input.value = value;
editor.flatpickr.setDate(value ? new Date(value) : new Date());
},
});
const ExampleComponent = () => {
return (
<HotTable
data={data}
colHeaders={['Product', 'Version', 'Release (EU)', 'Release (US)', 'Status']}
autoRowSize={true}
rowHeaders={true}
height="auto"
width="100%"
autoWrapRow={true}
headerClassName="htLeft"
licenseKey="non-commercial-and-evaluation"
>
<HotColumn data="product" type="text" width={200} />
<HotColumn data="version" type="text" width={80} />
<HotColumn
data="releaseDate"
width={130}
allowInvalid={false}
hotRenderer={flatpickrRenderer}
hotEditor={flatpickrEditor}
validator={flatpickrValidator}
renderFormat={DATE_FORMAT_EU}
flatpickrSettings={{ locale: { firstDayOfWeek: 1 } }}
/>
<HotColumn
data="releaseDate"
width={130}
allowInvalid={false}
hotRenderer={flatpickrRenderer}
hotEditor={flatpickrEditor}
validator={flatpickrValidator}
renderFormat={DATE_FORMAT_US}
flatpickrSettings={{ locale: { firstDayOfWeek: 0 } }}
/>
<HotColumn data="status" type="text" width={130} />
</HotTable>
);
};
export default ExampleComponent;
CSS
.flatpickr-editor {
width: 100%;
height: 100%;
box-sizing: border-box !important;
border: none;
border-radius: 0;
outline: none;
box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
var(--ht-cell-editor-border-color, #1a42e8),
0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
var(--ht-cell-editor-shadow-color, transparent) !important;
background-color: var(--ht-cell-editor-background-color, #ffffff) !important;
padding: var(--ht-cell-vertical-padding, 4px)
var(--ht-cell-horizontal-padding, 8px) !important;
border: none !important;
font-family: inherit;
font-size: inherit;
line-height: inherit;
}
.flatpickr-editor:focus-visible {
border: none !important;
}
.flatpickr-editor.active {
box-shadow: none;
background-color: transparent;
border-radius: 0 !important;
border-radius: none;
}

Overview

This guide shows how to create a custom date picker cell using Flatpickr, a date picker library that provides better cross-browser consistency and more customization options than native HTML5 date inputs.

Difficulty: Intermediate Time: ~20 minutes Libraries: flatpickr, date-fns

What You’ll Build

A cell that:

  • Displays formatted dates (e.g., “12/31/2024” or “31/12/2024”)
  • Opens a beautiful calendar picker when edited
  • Supports per-column configuration (EU vs US date formats)
  • Handles locale-specific settings (first day of week)
  • Auto-closes and saves when a date is selected
  • Supports dark theme with dynamic stylesheet loading

Prerequisites

Terminal window
npm install flatpickr date-fns
  1. Import Dependencies

    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    import { format, isValid, parseISO } from 'date-fns';
    import flatpickr from 'flatpickr';
    import 'flatpickr/dist/flatpickr.css';
    import { editorFactory } from 'handsontable/editors';
    import { rendererFactory } from 'handsontable/renderers';
    registerAllModules();

    Why date-fns?

    • Lightweight, modular date formatting
    • Better than native toLocaleDateString() for consistency
    • Can be replaced with other libraries (moment, dayjs, etc.)
    • parseISO parses the yyyy-MM-dd values the recipe stores, and isValid guards validation and rendering against invalid dates

    Why editorFactory and rendererFactory?

    • editorFactory creates a custom editor with lifecycle hooks (init, beforeOpen, afterOpen, afterClose, getValue, setValue, etc.)
    • rendererFactory creates a custom renderer with access to cell properties
    • Both are Handsontable helpers that handle boilerplate like container creation, positioning, and lifecycle management
  2. Define Date Formats

    const DATE_FORMAT_US = 'MM/dd/yyyy';
    const DATE_FORMAT_EU = 'dd/MM/yyyy';

    Why constants?

    • Reusability across renderer and column configuration
    • Single source of truth
    • Add more formats (ISO, custom, etc.) by extending this list
  3. Create the Renderer

    The renderer displays the date in a human-readable format.

    renderer: rendererFactory(({ td, value, cellProperties }) => {
    const date = parseISO(value);
    td.innerText = value && isValid(date) ? format(date, cellProperties.renderFormat) : value || '';
    })

    What’s happening:

    • value is the raw date value (e.g., ISO string “2025-03-15”)
    • Empty values are shown as an empty string
    • parseISO() parses the ISO string; unlike new Date(), it rejects impossible dates such as “2025-02-30” instead of rolling them over to March
    • isValid() guards format(), which throws RangeError: Invalid time value for an invalid date; an unparseable value is shown as-is
    • cellProperties.renderFormat is a custom property we’ll set per column
    • format() from date-fns converts to desired format
    • Display the formatted date

    Why use cellProperties?

    • Allows different columns to display dates differently
    • One cell definition, multiple configurations

    Optional error highlighting for production:

    renderer: rendererFactory(({ td, value, cellProperties }) => {
    if (!value) {
    td.innerText = '';
    td.style.color = '';
    return;
    }
    const date = parseISO(value);
    if (!isValid(date)) {
    td.innerText = 'Invalid date';
    td.style.color = 'red';
    return;
    }
    td.innerText = format(date, cellProperties.renderFormat || 'MM/dd/yyyy');
    td.style.color = '';
    })
  4. Create the Validator

    validator: (value, callback) => {
    callback(!value || isValid(parseISO(value)));
    }

    What’s happening:

    • Uses parseISO and isValid from date-fns to validate the date
    • parseISO(value) always returns a Date object, so checking its type (isDate) accepts any input; isValid also rejects an Invalid Date
    • parseISO rejects impossible dates such as “2025-02-30”, which new Date() silently rolls over to “2025-03-02”
    • Empty values pass, so users can clear a cell
    • Returns true for valid dates and empty values, false for invalid ones

    Alternative validation approaches:

    // Using native JavaScript
    validator: (value, callback) => {
    const date = new Date(value);
    callback(!value || !isNaN(date.getTime()));
    }

    The native version also allows empty values, but new Date() rolls impossible dates such as “2025-02-30” over instead of rejecting them.

  5. Editor - Initialize (init)

    Create the input element, initialize Flatpickr, and prepare the dark theme.

    init(editor) {
    editor.input = editor.hot.rootDocument.createElement('INPUT') as HTMLInputElement;
    editor.input.classList.add('flatpickr-editor');
    editor.flatpickr = flatpickr(editor.input, {
    dateFormat: 'Y-m-d',
    disableMobile: true,
    onClose: () => {
    editor.finishEditing();
    },
    });
    editor.preventCloseElement = editor.flatpickr.calendarContainer;
    /**
    * Prepare dark theme stylesheet for dynamic loading.
    */
    editor._darkThemeLink = editor.hot.rootDocument.createElement('LINK') as HTMLLinkElement;
    editor._darkThemeLink.rel = 'stylesheet';
    editor._darkThemeLink.href = 'https://cdn.jsdelivr.net/npm/flatpickr/dist/themes/dark.css';
    }

    What’s happening:

    1. Create an input element and add the flatpickr-editor CSS class for styling
    2. Initialize Flatpickr on the input with an onClose handler that calls finishEditing() when the calendar closes (e.g., after selecting a date or pressing Escape)
    3. Set preventCloseElement to the Flatpickr calendar container so that clicks inside the calendar are not treated as “outside” clicks — this keeps the editor open while the user selects a date
    4. Create a <link> element for the dark theme (loaded dynamically in afterOpen)

    Key concepts:

    The onClose handler

    onClose: () => {
    editor.finishEditing();
    },

    When the user selects a date or closes the calendar (e.g., Escape), Flatpickr fires onClose. Calling finishEditing() saves the value and closes the editor.

    The CSS class

    editor.input.classList.add('flatpickr-editor');

    Adds a CSS class to style the input element using Handsontable’s CSS custom properties (tokens). See the CSS file for details.

    The preventCloseElement pattern

    Without it:

    1. User clicks cell to edit
    2. Flatpickr calendar opens
    3. User clicks on the calendar
    4. Handsontable treats the click as “outside” the editor and closes it

    Solution: Assign the Flatpickr calendar container to editor.preventCloseElement. The editor factory treats this element as part of the editor, so clicks inside it do not close the editor prematurely.

  6. Editor - After Close Hook (afterClose)

    Close the Flatpickr calendar when the editor is closed by non-Flatpickr means (e.g., Escape key or clicking outside).

    afterClose(editor) {
    editor.flatpickr.close();
    }

    What’s happening:

    • When the user closes the editor by pressing Escape or clicking outside the cell, Handsontable closes the editor but Flatpickr’s calendar popup is not automatically closed
    • The afterClose hook runs when the editor is about to close; calling editor.flatpickr.close() ensures the calendar is hidden
    • Without this hook, the calendar would remain visible on screen after the editor has closed
  7. Editor - After Open Hook (afterOpen)

    Toggle the dark theme when the editor opens, then open the Flatpickr calendar.

    afterOpen(editor) {
    const isDark = editor.hot.rootDocument.documentElement.getAttribute('data-theme') === 'dark';
    const head = editor.hot.rootDocument.head;
    if (isDark && !editor._darkThemeLink.parentNode) {
    head.appendChild(editor._darkThemeLink);
    } else if (!isDark && editor._darkThemeLink.parentNode) {
    head.removeChild(editor._darkThemeLink);
    }
    editor.flatpickr.open();
    }

    What’s happening:

    1. Check the current theme by reading the data-theme attribute on the <html> element
    2. Dynamically add or remove the Flatpickr dark theme stylesheet
    3. Call editor.flatpickr.open() to show the calendar (the editor factory does not open Flatpickr automatically)

    Why dynamic theme loading?

    • Flatpickr themes are CSS files, not runtime APIs
    • Importing CSS directly (import 'flatpickr/dist/themes/dark.css') doesn’t work in all build environments
    • Dynamic <link> injection allows toggling the theme each time the editor opens
    • The theme stylesheet is loaded from jsDelivr CDN and cached by the browser
  8. Editor - Before Open Hook (beforeOpen)

    Apply per-column Flatpickr settings.

    beforeOpen(editor, { cellProperties }) {
    for (const key in cellProperties.flatpickrSettings) {
    editor.flatpickr.set(key as keyof flatpickr.Options.Options, cellProperties.flatpickrSettings[key]);
    }
    }

    What’s happening:

    1. Update Flatpickr settings from cellProperties.flatpickrSettings (e.g., locale, first day of week)
    2. The editor’s value is set by the framework before beforeOpen runs

    Key points:

    • beforeOpen is called before the editor opens
    • cellProperties.flatpickrSettings contains column-specific Flatpickr configuration
    • flatpickr.set() updates the existing Flatpickr instance with new settings

    Why update settings in beforeOpen?

    • Allows different columns to have different Flatpickr configurations (e.g., EU vs US first day of week)
    • Settings are applied before opening, ensuring they are current
    • More efficient than reinitializing Flatpickr each time
  9. Editor - Get Value (getValue)

    Return the current date value from the input.

    getValue(editor) {
    return editor.input.value;
    }

    What’s happening:

    • Flatpickr automatically updates input.value in ISO format (e.g., “2025-03-15”)
    • Return the input’s current value
    • Called when Handsontable needs to save the cell value
  10. Editor - Set Value (setValue)

    Initialize the editor with the cell’s current date value.

    setValue(editor, value) {
    editor.input.value = value;
    editor.flatpickr.setDate(value ? new Date(value) : new Date());
    }

    What’s happening:

    • Set the input’s value to the provided date string
    • Update Flatpickr’s selected date using setDate() — use the cell value if present, otherwise the current date
    • This ensures Flatpickr displays the correct date when opened
    • Called to initialize the editor with the cell’s current value
  11. Style the Editor with CSS

    The editor input needs styling to match Handsontable’s cell appearance. Create a CSS file using Handsontable’s CSS custom properties (tokens):

    .flatpickr-editor {
    width: 100%;
    height: 100%;
    box-sizing: border-box !important;
    border: none;
    border-radius: 0;
    outline: none;
    box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
    var(--ht-cell-editor-border-color, #1a42e8),
    0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
    var(--ht-cell-editor-shadow-color, transparent) !important;
    background-color: var(--ht-cell-editor-background-color, #ffffff) !important;
    padding: var(--ht-cell-vertical-padding, 4px)
    var(--ht-cell-horizontal-padding, 8px) !important;
    border: none !important;
    font-family: inherit;
    font-size: inherit;
    line-height: inherit;
    }
    .flatpickr-editor:focus-visible {
    border: none !important;
    }
    .flatpickr-editor.active {
    box-shadow: none;
    background-color: transparent;
    border-radius: 0 !important;
    }

    Why use CSS custom properties?

    • --ht-cell-editor-border-width and --ht-cell-editor-border-color match the default Handsontable editor border
    • --ht-cell-editor-background-color ensures the editor background matches the cell
    • --ht-cell-vertical-padding and --ht-cell-horizontal-padding align text with the cell content
    • These tokens automatically adapt when using custom Handsontable themes

    The .active state: When the editor is active (calendar open), the input border and background are hidden since the calendar itself provides the visual feedback.

  12. Complete Cell Definition

    TypeScript: Define an interface for the editor instance (optional in JavaScript):

    interface FlatpickrEditorInstance {
    input: HTMLInputElement;
    flatpickr: flatpickr.Instance;
    preventCloseElement: HTMLElement;
    _darkThemeLink: HTMLLinkElement;
    }

    Put it all together:

    const cellDefinition = {
    validator: (value, callback) => {
    callback(!value || isValid(parseISO(value)));
    },
    renderer: rendererFactory(({ td, value, cellProperties }) => {
    const date = parseISO(value);
    td.innerText = value && isValid(date) ? format(date, cellProperties.renderFormat) : value || '';
    }),
    editor: editorFactory<FlatpickrEditorInstance>({
    init(editor) {
    editor.input = editor.hot.rootDocument.createElement('INPUT') as HTMLInputElement;
    editor.input.classList.add('flatpickr-editor');
    editor.flatpickr = flatpickr(editor.input, {
    dateFormat: 'Y-m-d',
    disableMobile: true,
    onClose: () => {
    editor.finishEditing();
    },
    });
    editor.preventCloseElement = editor.flatpickr.calendarContainer;
    editor._darkThemeLink = editor.hot.rootDocument.createElement('LINK') as HTMLLinkElement;
    editor._darkThemeLink.rel = 'stylesheet';
    editor._darkThemeLink.href = 'https://cdn.jsdelivr.net/npm/flatpickr/dist/themes/dark.css';
    },
    afterClose(editor) {
    editor.flatpickr.close();
    },
    afterOpen(editor) {
    const isDark = editor.hot.rootDocument.documentElement.getAttribute('data-theme') === 'dark';
    const head = editor.hot.rootDocument.head;
    if (isDark && !editor._darkThemeLink.parentNode) {
    head.appendChild(editor._darkThemeLink);
    } else if (!isDark && editor._darkThemeLink.parentNode) {
    head.removeChild(editor._darkThemeLink);
    }
    editor.flatpickr.open();
    },
    beforeOpen(editor, { cellProperties }) {
    for (const key in cellProperties.flatpickrSettings) {
    editor.flatpickr.set(key as keyof flatpickr.Options.Options, cellProperties.flatpickrSettings[key]);
    }
    },
    getValue(editor) {
    return editor.input.value;
    },
    setValue(editor, value) {
    editor.input.value = value;
    editor.flatpickr.setDate(value ? new Date(value) : new Date());
    },
    }),
    };

    What’s happening:

    • validator: Ensures date is valid using parseISO and isValid from date-fns
    • renderer: Displays formatted date using cellProperties.renderFormat (empty string for missing values, the raw value for invalid dates)
    • editor: Uses editorFactory helper with:
      • init: Creates input, initializes Flatpickr with onClose calling finishEditing(), sets preventCloseElement so calendar clicks don’t close the editor, prepares dark theme link
      • afterClose: Closes the Flatpickr calendar when the editor is closed by Escape or clicking outside
      • afterOpen: Toggles dark theme stylesheet and opens the Flatpickr calendar
      • beforeOpen: Applies per-column Flatpickr settings from cellProperties.flatpickrSettings
      • getValue: Returns the input’s current value
      • setValue: Sets input value and Flatpickr’s selected date

    Note: The editorFactory helper handles container creation, positioning, and lifecycle management automatically.

  13. Use in Handsontable with Different Formats

    const container = document.querySelector('#example1');
    const hotOptions = {
    data,
    colHeaders: ['Product', 'Version', 'Release (EU)', 'Release (US)', 'Status'],
    autoRowSize: true,
    rowHeaders: true,
    height: 'auto',
    width: '100%',
    autoWrapRow: true,
    headerClassName: 'htLeft',
    columns: [
    { data: 'product', type: 'text', width: 200 },
    { data: 'version', type: 'text', width: 80 },
    {
    data: 'releaseDate',
    width: 130,
    allowInvalid: false,
    ...cellDefinition,
    renderFormat: DATE_FORMAT_EU,
    flatpickrSettings: {
    locale: {
    firstDayOfWeek: 1,
    },
    },
    },
    {
    data: 'releaseDate',
    width: 130,
    allowInvalid: false,
    ...cellDefinition,
    renderFormat: DATE_FORMAT_US,
    flatpickrSettings: {
    locale: {
    firstDayOfWeek: 0,
    },
    },
    },
    { data: 'status', type: 'text', width: 130 },
    ],
    licenseKey: 'non-commercial-and-evaluation',
    };
    const hot = new Handsontable(container, hotOptions);

    TypeScript: Use const container = document.querySelector('#example1')! and type the options as Handsontable.GridSettings.

    Key feature:

    • Same data column (releaseDate)
    • Two different display formats (EU vs US)
    • Two different calendar configurations (Monday vs Sunday first day)
    • One cell definition!

How It Works - Complete Flow

  1. Initial Load: Cell displays formatted date (“15/03/2025” EU or “03/15/2025” US), empty string when there is no value, or the raw value when it isn’t a valid date
  2. User Double-Clicks or F2: Editor opens, container positioned over cell
  3. Before Open: beforeOpen applies per-column Flatpickr settings (e.g., first day of week)
  4. After Open: afterOpen toggles dark theme if needed and calls editor.flatpickr.open() to show the calendar
  5. Calendar Opens: Flatpickr displays the calendar with column-specific settings
  6. User Selects Date or Closes Calendar: onClose handler fires, calls finishEditing()
  7. Validation: Validator checks date is valid using parseISO and isValid
  8. Save: Value saved in ISO format (“2025-03-15”)
  9. Editor Closes: afterClose runs and closes the Flatpickr calendar (important when the user closed via Escape or clicking outside). Container hidden, cell renderer displays the new formatted date

Advanced Enhancements

  1. Time Picker

    Add time selection:

    flatpickrSettings: {
    enableTime: true,
    dateFormat: 'Y-m-d H:i',
    time_24hr: true
    }
    // Update renderer
    renderFormat: 'dd/MM/yyyy HH:mm'
  2. Date Range Restrictions

    Limit selectable dates:

    flatpickrSettings: {
    minDate: '2024-01-01',
    maxDate: '2024-12-31',
    disable: [
    // Disable weekends
    function(date) {
    return (date.getDay() === 0 || date.getDay() === 6);
    }
    ]
    }
  3. Inline Calendar

    Show calendar always visible:

    flatpickrSettings: {
    inline: true,
    static: true
    }
    // Adjust wrapper height in open()
    editor.container.style.height = '300px';
  4. Multiple Date Locales

    Use Flatpickr locales:

    import { French } from 'flatpickr/dist/l10n/fr.js';
    flatpickrSettings: {
    locale: French,
    dateFormat: 'd/m/Y'
    }
  5. Custom Date Ranges

    Add shortcuts:

    // Requires flatpickr shortcutButtonsPlugin
    import ShortcutButtonsPlugin from 'flatpickr/dist/plugins/shortcutButtons/shortcutButtons.js';
    flatpickrSettings: {
    plugins: [
    ShortcutButtonsPlugin({
    button: [
    { label: 'Today' },
    { label: 'Next Week' },
    ],
    onClick: (index, fp) => {
    let date;
    if (index === 0) {
    date = new Date();
    } else if (index === 1) {
    date = new Date();
    date.setDate(date.getDate() + 7);
    }
    fp.setDate(date);
    }
    })
    ]
    }

What you learned

You integrated the Flatpickr date picker as a Handsontable cell editor. You used editorFactory to manage the editor lifecycle, preventCloseElement to keep the calendar open while the user picks a date, and cellProperties to drive per-column format and locale configuration.

Next steps

  • Pikaday - An alternative date picker using Pikaday and Moment.js, with portal positioning.
  • Moment.js date - A date cell type that layers Moment.js formatting over the built-in date cell type.
  • Date picker (Angular) - A date editor built with Angular components and the native HTML5 date input.

Skip to content

Flatpickr

This tutorial shows you how to integrate the Flatpickr date picker as a custom Handsontable cell editor, with per-column locale and format configuration.

TypeScript
/* file: app.component.ts */
import { Component, ChangeDetectionStrategy, ElementRef, ViewChild } from '@angular/core';
import {
HotCellEditorAdvancedComponent,
HotCellRendererAdvancedComponent,
GridSettings,
HotTableModule
} from '@handsontable/angular-wrapper';
import { format, isDate, isValid, parseISO } from 'date-fns';
import flatpickr from 'flatpickr';
import 'flatpickr/dist/flatpickr.css';
const DATE_FORMAT_US = 'MM/dd/yyyy';
const DATE_FORMAT_EU = 'dd/MM/yyyy';
@Component({
standalone: true,
selector: 'example1-flatpickr-editor',
template: `<input #pickerInput class="flatpickr-editor" type="text" />`,
styles: [
`
:host {
width: 100%;
height: 100%;
}
.flatpickr-editor {
width: 100%;
height: 100%;
border: none;
box-sizing: border-box !important;
padding: 4px 8px;
}
`,
],
})
export class FlatpickrEditorComponent extends HotCellEditorAdvancedComponent<string> {
@ViewChild('pickerInput', { static: true }) pickerInput!: ElementRef<HTMLInputElement>;
private fpInstance: ReturnType<typeof flatpickr> | null = null;
override afterOpen(): void {
this.fpInstance = flatpickr(this.pickerInput.nativeElement, {
dateFormat: 'Y-m-d',
disableMobile: true,
defaultDate: this.value || undefined,
onClose: () => {
this.finishEdit.emit();
},
});
(this.fpInstance as any).open?.();
}
override afterClose(): void {
(this.fpInstance as any)?.destroy?.();
this.fpInstance = null;
}
override onFocus(): void {
this.pickerInput.nativeElement.focus();
}
}
@Component({
standalone: true,
selector: 'example1-flatpickr-renderer',
changeDetection: ChangeDetectionStrategy.OnPush,
template: `<span>{{ formattedDate }}</span>`,
})
export class FlatpickrRendererComponent extends HotCellRendererAdvancedComponent<
string,
{ renderFormat: string }
> {
get formattedDate(): string {
if (!this.value) return '';
try {
const d = parseISO(this.value);
return isDate(d) && isValid(d)
? format(d, this.getProps().renderFormat || 'MM/dd/yyyy')
: this.value;
} catch {
return this.value;
}
}
}
@Component({
standalone: true,
imports: [HotTableModule],
selector: 'example1-flatpickr',
template: `<div><hot-table [data]="data" [settings]="gridSettings"></hot-table></div>`,
})
export class AppComponent {
readonly data = [
{ product: 'Dashboard Pro', version: '3.2.0', releaseDate: '2025-03-15', status: 'Released' },
{ product: 'Form Builder', version: '2.1.0', releaseDate: '2025-04-22', status: 'Released' },
{ product: 'Chart Engine', version: '4.0.0', releaseDate: '2025-06-10', status: 'Beta' },
{ product: 'Auth Module', version: '1.5.2', releaseDate: '2025-07-01', status: 'Released' },
{ product: 'File Manager', version: '2.0.0', releaseDate: '2025-08-18', status: 'Planned' },
{ product: 'Email Service', version: '3.1.0', releaseDate: '2025-09-05', status: 'Released' },
{ product: 'Search Index', version: '1.2.0', releaseDate: '2025-10-12', status: 'Beta' },
{ product: 'Cache Layer', version: '2.3.1', releaseDate: '2025-11-28', status: 'Planned' },
];
readonly gridSettings: GridSettings = {
colHeaders: ['Product', 'Version', 'Release (EU)', 'Release (US)', 'Status'],
autoRowSize: true,
rowHeaders: true,
height: 'auto',
width: '100%',
autoWrapRow: true,
headerClassName: 'htLeft',
columns: [
{ data: 'product', type: 'text', width: 200 },
{ data: 'version', type: 'text', width: 80 },
{
data: 'releaseDate',
width: 130,
allowInvalid: false,
editor: FlatpickrEditorComponent,
renderer: FlatpickrRendererComponent,
rendererProps: {
renderFormat: DATE_FORMAT_EU,
},
} as any,
{
data: 'releaseDate',
width: 130,
allowInvalid: false,
editor: FlatpickrEditorComponent,
renderer: FlatpickrRendererComponent,
rendererProps: {
renderFormat: DATE_FORMAT_US,
},
} as any,
{ data: 'status', type: 'text', width: 130 },
],
};
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div>
<example1-flatpickr></example1-flatpickr>
</div>

Overview

This guide shows how to create a custom date picker cell using Flatpickr, a date picker library that provides better cross-browser consistency and more customization options than native HTML5 date inputs.

Difficulty: Intermediate Time: ~20 minutes Libraries: flatpickr, date-fns

What You’ll Build

A cell that:

  • Displays formatted dates (e.g., “12/31/2024” or “31/12/2024”)
  • Opens a beautiful calendar picker when edited
  • Supports per-column configuration (EU vs US date formats)
  • Handles locale-specific settings (first day of week)
  • Auto-closes and saves when a date is selected
  • Supports dark theme with dynamic stylesheet loading

Prerequisites

Terminal window
npm install flatpickr date-fns
  1. Import Dependencies

    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    import { format, isValid, parseISO } from 'date-fns';
    import flatpickr from 'flatpickr';
    import 'flatpickr/dist/flatpickr.css';
    import { editorFactory } from 'handsontable/editors';
    import { rendererFactory } from 'handsontable/renderers';
    registerAllModules();

    Why date-fns?

    • Lightweight, modular date formatting
    • Better than native toLocaleDateString() for consistency
    • Can be replaced with other libraries (moment, dayjs, etc.)
    • parseISO parses the yyyy-MM-dd values the recipe stores, and isValid guards validation and rendering against invalid dates

    Why editorFactory and rendererFactory?

    • editorFactory creates a custom editor with lifecycle hooks (init, beforeOpen, afterOpen, afterClose, getValue, setValue, etc.)
    • rendererFactory creates a custom renderer with access to cell properties
    • Both are Handsontable helpers that handle boilerplate like container creation, positioning, and lifecycle management
  2. Define Date Formats

    const DATE_FORMAT_US = 'MM/dd/yyyy';
    const DATE_FORMAT_EU = 'dd/MM/yyyy';

    Why constants?

    • Reusability across renderer and column configuration
    • Single source of truth
    • Add more formats (ISO, custom, etc.) by extending this list
  3. Create the Renderer

    The renderer displays the date in a human-readable format.

    renderer: rendererFactory(({ td, value, cellProperties }) => {
    const date = parseISO(value);
    td.innerText = value && isValid(date) ? format(date, cellProperties.renderFormat) : value || '';
    })

    What’s happening:

    • value is the raw date value (e.g., ISO string “2025-03-15”)
    • Empty values are shown as an empty string
    • parseISO() parses the ISO string; unlike new Date(), it rejects impossible dates such as “2025-02-30” instead of rolling them over to March
    • isValid() guards format(), which throws RangeError: Invalid time value for an invalid date; an unparseable value is shown as-is
    • cellProperties.renderFormat is a custom property we’ll set per column
    • format() from date-fns converts to desired format
    • Display the formatted date

    Why use cellProperties?

    • Allows different columns to display dates differently
    • One cell definition, multiple configurations

    Optional error highlighting for production:

    renderer: rendererFactory(({ td, value, cellProperties }) => {
    if (!value) {
    td.innerText = '';
    td.style.color = '';
    return;
    }
    const date = parseISO(value);
    if (!isValid(date)) {
    td.innerText = 'Invalid date';
    td.style.color = 'red';
    return;
    }
    td.innerText = format(date, cellProperties.renderFormat || 'MM/dd/yyyy');
    td.style.color = '';
    })
  4. Create the Validator

    validator: (value, callback) => {
    callback(!value || isValid(parseISO(value)));
    }

    What’s happening:

    • Uses parseISO and isValid from date-fns to validate the date
    • parseISO(value) always returns a Date object, so checking its type (isDate) accepts any input; isValid also rejects an Invalid Date
    • parseISO rejects impossible dates such as “2025-02-30”, which new Date() silently rolls over to “2025-03-02”
    • Empty values pass, so users can clear a cell
    • Returns true for valid dates and empty values, false for invalid ones

    Alternative validation approaches:

    // Using native JavaScript
    validator: (value, callback) => {
    const date = new Date(value);
    callback(!value || !isNaN(date.getTime()));
    }

    The native version also allows empty values, but new Date() rolls impossible dates such as “2025-02-30” over instead of rejecting them.

  5. Editor - Initialize (init)

    Create the input element, initialize Flatpickr, and prepare the dark theme.

    init(editor) {
    editor.input = editor.hot.rootDocument.createElement('INPUT') as HTMLInputElement;
    editor.input.classList.add('flatpickr-editor');
    editor.flatpickr = flatpickr(editor.input, {
    dateFormat: 'Y-m-d',
    disableMobile: true,
    onClose: () => {
    editor.finishEditing();
    },
    });
    editor.preventCloseElement = editor.flatpickr.calendarContainer;
    /**
    * Prepare dark theme stylesheet for dynamic loading.
    */
    editor._darkThemeLink = editor.hot.rootDocument.createElement('LINK') as HTMLLinkElement;
    editor._darkThemeLink.rel = 'stylesheet';
    editor._darkThemeLink.href = 'https://cdn.jsdelivr.net/npm/flatpickr/dist/themes/dark.css';
    }

    What’s happening:

    1. Create an input element and add the flatpickr-editor CSS class for styling
    2. Initialize Flatpickr on the input with an onClose handler that calls finishEditing() when the calendar closes (e.g., after selecting a date or pressing Escape)
    3. Set preventCloseElement to the Flatpickr calendar container so that clicks inside the calendar are not treated as “outside” clicks — this keeps the editor open while the user selects a date
    4. Create a <link> element for the dark theme (loaded dynamically in afterOpen)

    Key concepts:

    The onClose handler

    onClose: () => {
    editor.finishEditing();
    },

    When the user selects a date or closes the calendar (e.g., Escape), Flatpickr fires onClose. Calling finishEditing() saves the value and closes the editor.

    The CSS class

    editor.input.classList.add('flatpickr-editor');

    Adds a CSS class to style the input element using Handsontable’s CSS custom properties (tokens). See the CSS file for details.

    The preventCloseElement pattern

    Without it:

    1. User clicks cell to edit
    2. Flatpickr calendar opens
    3. User clicks on the calendar
    4. Handsontable treats the click as “outside” the editor and closes it

    Solution: Assign the Flatpickr calendar container to editor.preventCloseElement. The editor factory treats this element as part of the editor, so clicks inside it do not close the editor prematurely.

  6. Editor - After Close Hook (afterClose)

    Close the Flatpickr calendar when the editor is closed by non-Flatpickr means (e.g., Escape key or clicking outside).

    afterClose(editor) {
    editor.flatpickr.close();
    }

    What’s happening:

    • When the user closes the editor by pressing Escape or clicking outside the cell, Handsontable closes the editor but Flatpickr’s calendar popup is not automatically closed
    • The afterClose hook runs when the editor is about to close; calling editor.flatpickr.close() ensures the calendar is hidden
    • Without this hook, the calendar would remain visible on screen after the editor has closed
  7. Editor - After Open Hook (afterOpen)

    Toggle the dark theme when the editor opens, then open the Flatpickr calendar.

    afterOpen(editor) {
    const isDark = editor.hot.rootDocument.documentElement.getAttribute('data-theme') === 'dark';
    const head = editor.hot.rootDocument.head;
    if (isDark && !editor._darkThemeLink.parentNode) {
    head.appendChild(editor._darkThemeLink);
    } else if (!isDark && editor._darkThemeLink.parentNode) {
    head.removeChild(editor._darkThemeLink);
    }
    editor.flatpickr.open();
    }

    What’s happening:

    1. Check the current theme by reading the data-theme attribute on the <html> element
    2. Dynamically add or remove the Flatpickr dark theme stylesheet
    3. Call editor.flatpickr.open() to show the calendar (the editor factory does not open Flatpickr automatically)

    Why dynamic theme loading?

    • Flatpickr themes are CSS files, not runtime APIs
    • Importing CSS directly (import 'flatpickr/dist/themes/dark.css') doesn’t work in all build environments
    • Dynamic <link> injection allows toggling the theme each time the editor opens
    • The theme stylesheet is loaded from jsDelivr CDN and cached by the browser
  8. Editor - Before Open Hook (beforeOpen)

    Apply per-column Flatpickr settings.

    beforeOpen(editor, { cellProperties }) {
    for (const key in cellProperties.flatpickrSettings) {
    editor.flatpickr.set(key as keyof flatpickr.Options.Options, cellProperties.flatpickrSettings[key]);
    }
    }

    What’s happening:

    1. Update Flatpickr settings from cellProperties.flatpickrSettings (e.g., locale, first day of week)
    2. The editor’s value is set by the framework before beforeOpen runs

    Key points:

    • beforeOpen is called before the editor opens
    • cellProperties.flatpickrSettings contains column-specific Flatpickr configuration
    • flatpickr.set() updates the existing Flatpickr instance with new settings

    Why update settings in beforeOpen?

    • Allows different columns to have different Flatpickr configurations (e.g., EU vs US first day of week)
    • Settings are applied before opening, ensuring they are current
    • More efficient than reinitializing Flatpickr each time
  9. Editor - Get Value (getValue)

    Return the current date value from the input.

    getValue(editor) {
    return editor.input.value;
    }

    What’s happening:

    • Flatpickr automatically updates input.value in ISO format (e.g., “2025-03-15”)
    • Return the input’s current value
    • Called when Handsontable needs to save the cell value
  10. Editor - Set Value (setValue)

    Initialize the editor with the cell’s current date value.

    setValue(editor, value) {
    editor.input.value = value;
    editor.flatpickr.setDate(value ? new Date(value) : new Date());
    }

    What’s happening:

    • Set the input’s value to the provided date string
    • Update Flatpickr’s selected date using setDate() — use the cell value if present, otherwise the current date
    • This ensures Flatpickr displays the correct date when opened
    • Called to initialize the editor with the cell’s current value
  11. Style the Editor with CSS

    The editor input needs styling to match Handsontable’s cell appearance. Create a CSS file using Handsontable’s CSS custom properties (tokens):

    .flatpickr-editor {
    width: 100%;
    height: 100%;
    box-sizing: border-box !important;
    border: none;
    border-radius: 0;
    outline: none;
    box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
    var(--ht-cell-editor-border-color, #1a42e8),
    0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
    var(--ht-cell-editor-shadow-color, transparent) !important;
    background-color: var(--ht-cell-editor-background-color, #ffffff) !important;
    padding: var(--ht-cell-vertical-padding, 4px)
    var(--ht-cell-horizontal-padding, 8px) !important;
    border: none !important;
    font-family: inherit;
    font-size: inherit;
    line-height: inherit;
    }
    .flatpickr-editor:focus-visible {
    border: none !important;
    }
    .flatpickr-editor.active {
    box-shadow: none;
    background-color: transparent;
    border-radius: 0 !important;
    }

    Why use CSS custom properties?

    • --ht-cell-editor-border-width and --ht-cell-editor-border-color match the default Handsontable editor border
    • --ht-cell-editor-background-color ensures the editor background matches the cell
    • --ht-cell-vertical-padding and --ht-cell-horizontal-padding align text with the cell content
    • These tokens automatically adapt when using custom Handsontable themes

    The .active state: When the editor is active (calendar open), the input border and background are hidden since the calendar itself provides the visual feedback.

  12. Complete Cell Definition

    TypeScript: Define an interface for the editor instance (optional in JavaScript):

    interface FlatpickrEditorInstance {
    input: HTMLInputElement;
    flatpickr: flatpickr.Instance;
    preventCloseElement: HTMLElement;
    _darkThemeLink: HTMLLinkElement;
    }

    Put it all together:

    const cellDefinition = {
    validator: (value, callback) => {
    callback(!value || isValid(parseISO(value)));
    },
    renderer: rendererFactory(({ td, value, cellProperties }) => {
    const date = parseISO(value);
    td.innerText = value && isValid(date) ? format(date, cellProperties.renderFormat) : value || '';
    }),
    editor: editorFactory<FlatpickrEditorInstance>({
    init(editor) {
    editor.input = editor.hot.rootDocument.createElement('INPUT') as HTMLInputElement;
    editor.input.classList.add('flatpickr-editor');
    editor.flatpickr = flatpickr(editor.input, {
    dateFormat: 'Y-m-d',
    disableMobile: true,
    onClose: () => {
    editor.finishEditing();
    },
    });
    editor.preventCloseElement = editor.flatpickr.calendarContainer;
    editor._darkThemeLink = editor.hot.rootDocument.createElement('LINK') as HTMLLinkElement;
    editor._darkThemeLink.rel = 'stylesheet';
    editor._darkThemeLink.href = 'https://cdn.jsdelivr.net/npm/flatpickr/dist/themes/dark.css';
    },
    afterClose(editor) {
    editor.flatpickr.close();
    },
    afterOpen(editor) {
    const isDark = editor.hot.rootDocument.documentElement.getAttribute('data-theme') === 'dark';
    const head = editor.hot.rootDocument.head;
    if (isDark && !editor._darkThemeLink.parentNode) {
    head.appendChild(editor._darkThemeLink);
    } else if (!isDark && editor._darkThemeLink.parentNode) {
    head.removeChild(editor._darkThemeLink);
    }
    editor.flatpickr.open();
    },
    beforeOpen(editor, { cellProperties }) {
    for (const key in cellProperties.flatpickrSettings) {
    editor.flatpickr.set(key as keyof flatpickr.Options.Options, cellProperties.flatpickrSettings[key]);
    }
    },
    getValue(editor) {
    return editor.input.value;
    },
    setValue(editor, value) {
    editor.input.value = value;
    editor.flatpickr.setDate(value ? new Date(value) : new Date());
    },
    }),
    };

    What’s happening:

    • validator: Ensures date is valid using parseISO and isValid from date-fns
    • renderer: Displays formatted date using cellProperties.renderFormat (empty string for missing values, the raw value for invalid dates)
    • editor: Uses editorFactory helper with:
      • init: Creates input, initializes Flatpickr with onClose calling finishEditing(), sets preventCloseElement so calendar clicks don’t close the editor, prepares dark theme link
      • afterClose: Closes the Flatpickr calendar when the editor is closed by Escape or clicking outside
      • afterOpen: Toggles dark theme stylesheet and opens the Flatpickr calendar
      • beforeOpen: Applies per-column Flatpickr settings from cellProperties.flatpickrSettings
      • getValue: Returns the input’s current value
      • setValue: Sets input value and Flatpickr’s selected date

    Note: The editorFactory helper handles container creation, positioning, and lifecycle management automatically.

  13. Use in Handsontable with Different Formats

    const container = document.querySelector('#example1');
    const hotOptions = {
    data,
    colHeaders: ['Product', 'Version', 'Release (EU)', 'Release (US)', 'Status'],
    autoRowSize: true,
    rowHeaders: true,
    height: 'auto',
    width: '100%',
    autoWrapRow: true,
    headerClassName: 'htLeft',
    columns: [
    { data: 'product', type: 'text', width: 200 },
    { data: 'version', type: 'text', width: 80 },
    {
    data: 'releaseDate',
    width: 130,
    allowInvalid: false,
    ...cellDefinition,
    renderFormat: DATE_FORMAT_EU,
    flatpickrSettings: {
    locale: {
    firstDayOfWeek: 1,
    },
    },
    },
    {
    data: 'releaseDate',
    width: 130,
    allowInvalid: false,
    ...cellDefinition,
    renderFormat: DATE_FORMAT_US,
    flatpickrSettings: {
    locale: {
    firstDayOfWeek: 0,
    },
    },
    },
    { data: 'status', type: 'text', width: 130 },
    ],
    licenseKey: 'non-commercial-and-evaluation',
    };
    const hot = new Handsontable(container, hotOptions);

    TypeScript: Use const container = document.querySelector('#example1')! and type the options as Handsontable.GridSettings.

    Key feature:

    • Same data column (releaseDate)
    • Two different display formats (EU vs US)
    • Two different calendar configurations (Monday vs Sunday first day)
    • One cell definition!

How It Works - Complete Flow

  1. Initial Load: Cell displays formatted date (“15/03/2025” EU or “03/15/2025” US), empty string when there is no value, or the raw value when it isn’t a valid date
  2. User Double-Clicks or F2: Editor opens, container positioned over cell
  3. Before Open: beforeOpen applies per-column Flatpickr settings (e.g., first day of week)
  4. After Open: afterOpen toggles dark theme if needed and calls editor.flatpickr.open() to show the calendar
  5. Calendar Opens: Flatpickr displays the calendar with column-specific settings
  6. User Selects Date or Closes Calendar: onClose handler fires, calls finishEditing()
  7. Validation: Validator checks date is valid using parseISO and isValid
  8. Save: Value saved in ISO format (“2025-03-15”)
  9. Editor Closes: afterClose runs and closes the Flatpickr calendar (important when the user closed via Escape or clicking outside). Container hidden, cell renderer displays the new formatted date

Advanced Enhancements

  1. Time Picker

    Add time selection:

    flatpickrSettings: {
    enableTime: true,
    dateFormat: 'Y-m-d H:i',
    time_24hr: true
    }
    // Update renderer
    renderFormat: 'dd/MM/yyyy HH:mm'
  2. Date Range Restrictions

    Limit selectable dates:

    flatpickrSettings: {
    minDate: '2024-01-01',
    maxDate: '2024-12-31',
    disable: [
    // Disable weekends
    function(date) {
    return (date.getDay() === 0 || date.getDay() === 6);
    }
    ]
    }
  3. Inline Calendar

    Show calendar always visible:

    flatpickrSettings: {
    inline: true,
    static: true
    }
    // Adjust wrapper height in open()
    editor.container.style.height = '300px';
  4. Multiple Date Locales

    Use Flatpickr locales:

    import { French } from 'flatpickr/dist/l10n/fr.js';
    flatpickrSettings: {
    locale: French,
    dateFormat: 'd/m/Y'
    }
  5. Custom Date Ranges

    Add shortcuts:

    // Requires flatpickr shortcutButtonsPlugin
    import ShortcutButtonsPlugin from 'flatpickr/dist/plugins/shortcutButtons/shortcutButtons.js';
    flatpickrSettings: {
    plugins: [
    ShortcutButtonsPlugin({
    button: [
    { label: 'Today' },
    { label: 'Next Week' },
    ],
    onClick: (index, fp) => {
    let date;
    if (index === 0) {
    date = new Date();
    } else if (index === 1) {
    date = new Date();
    date.setDate(date.getDate() + 7);
    }
    fp.setDate(date);
    }
    })
    ]
    }

What you learned

You integrated the Flatpickr date picker as a Handsontable cell editor. You used editorFactory to manage the editor lifecycle, preventCloseElement to keep the calendar open while the user picks a date, and cellProperties to drive per-column format and locale configuration.

Next steps

  • Pikaday - An alternative date picker using Pikaday and Moment.js, with portal positioning.
  • Moment.js date - A date cell type that layers Moment.js formatting over the built-in date cell type.
  • Date picker (Angular) - A date editor built with Angular components and the native HTML5 date input.